#
# Conditional build:
%bcond_with	system_dnet	# use system libdnet instead of local modified version
%bcond_without	python		# Python3 based scripts (zenmap, ndiff)
%bcond_without	lua		# Nmap Scripting Engine (lua based)

Summary:	Network exploration tool and security scanner
Summary(es.UTF-8):	Herramienta de exploración de la rede y seguridad
Summary(pl.UTF-8):	Program do badania i audytu sieci
Summary(pt_BR.UTF-8):	Ferramenta de exploração da rede e segurança
Summary(ru.UTF-8):	Утилита сканирования сети и аудита безопасности
Summary(uk.UTF-8):	Утиліта сканування мережі та аудиту безпеки
Name:		nmap
Version:	7.97
Release:	1
License:	Nmap Public Source License
Group:		Networking/Utilities
Source0:	https://nmap.org/dist/%{name}-%{version}.tar.bz2
# Source0-md5:	e4ac67fa85b4c2a93b49c811b1f0d163
Patch0:		%{name}-desktop.patch
Patch1:		ncat-system-ssl.patch
Patch2:		%{name}-python.patch
URL:		https://nmap.org/
BuildRequires:	autoconf >= 2.50
BuildRequires:	automake
BuildRequires:	gettext-tools
%{?with_system_dnet:BuildRequires:	libdnet-devel}
BuildRequires:	liblinear-devel
BuildRequires:	libpcap-devel
BuildRequires:	libstdc++-devel
BuildRequires:	libtool
%{?with_lua:BuildRequires:	lua54-devel >= 5.4}
BuildRequires:	openssl-devel
BuildRequires:	pcre-devel
BuildRequires:	python3-devel >= 1:3.6
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.672
BuildRequires:	sed >= 4.0
%if %{with python}
BuildRequires:	python3-build
BuildRequires:	python3-setuptools
BuildRequires:	python3-installer
Suggests:	%{name}-ndiff = %{version}-%{release}
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

#java code is run on target
%define		_noautoreqfiles	%{_datadir}/nmap/nselib/data/jdwp-class/.*

%description
Nmap is a utility for network exploration or security auditing. It
supports ping scanning (determine which hosts are up), many port
scanning techniques (determine what services the hosts are offering),
and TCP/IP fingerprinting (remote host operating system
identification). Nmap also offers flexible target and port
specification, decoy scanning, determination of TCP sequence
predictability characteristics, sunRPC scanning, reverse-identd
scanning, and more.

nmap supports a large number of scanning techniques such as: UDP, TCP
connect(), TCP SYN (half open), FTP proxy (bounce attack),
Reverse-ident, ICMP (ping sweep), FIN, ACK sweep, Xmas Tree, SYN
sweep, and Null scan.

%description -l es.UTF-8
Nmap es un utilitario para la exploración y auditoría de redes.
Soporta "ping scanning", varias técnicas de búsqueda de puertos
abiertos, e identificación remota de sistemas operacionales vía
impresiones digitales TCP/IP.

%description -l pl.UTF-8
Nmap jest programem przeznaczonym do badania i audytu sieci. Wspiera
różne techniki skanowania (badanie jakie usługi są uruchomione na
danym hoście), a także TCP/IP fingerprinting (zdalne rozpoznawanie
typu systemu operacyjnego). Nmap oferuje różne techniki skanowania
wykorzystujące: UDP, TCP connect(), TCP SYN (half open), FTP proxy
(bounce attack), Reverse-ident, ICMP (ping sweep), FIN, ACK sweep,
Xmas Tree, SYN sweep i Null scan.

%description -l pt_BR.UTF-8
Nmap é um utilitário para a exploração e auditoria de redes. Ele
suporta "ping scanning", várias técnicas de procura por portas
abertas, e identificação remota de sistemas operacionais via
impressões digitais TCP/IP.

%description -l ru.UTF-8
Nmap - это утилита для изучения сети и аудита безопасности. Она
поддерживает ping-сканирование (определение, какие хосты работают),
много методик сканирования портов (определение, какие сервисы
предоставляют хосты), и "отпечатки пальцев" TCP/IP (идентификация
операционной системы хоста). Nmap также поддерживает гибкое задание
цели и порта, скрытое сканирование (decoy scanning), определение
характеристик предсказуемости TCP sequence, сканирование sunRPC,
reverse-identd сканирование и другое.

%description -l uk.UTF-8
Nmap - це утиліта для дослідження мережі та аудиту безпеки. Вона
підтримує ping-сканування (визначення, які хости працюють), багато
методик сканування портів (визначення, які сервіси надають хости), та
"відбитки пальців" TCP/IP (ідентифікація операційної системи хоста).
Nmap також підтримує гнучке задання цілі та порта, приховане
сканування (decoy scanning), визначення характеристик передбачуваності
TCP sequence, сканування sunRPC, reverse-identd сканування та інше.

%package java
Summary:	NSE scripts that require Java
Summary(pl.UTF-8):	Skrypty NSE wykorzystujące Javę
Group:		Applications/Networking
Requires:	%{name} = %{version}-%{release}

%description java
NSE scripts that require Java.

%description java -l pl.UTF-8
Skrypty NSE wykorzystujące Javę.

%package ncat
Summary:	Nmap's Netcat replacement
Summary(pl.UTF-8):	Zamiennik Netcata z pakietu Nmap
Group:		Applications/System
Requires:	ca-certificates
Provides:	nc
Conflicts:	nmap < 6.47-3

%description ncat
Ncat is a feature packed networking utility which will read and write
data across a network from the command line. It uses both TCP and UDP
for communication and is designed to be a reliable back-end tool to
instantly provide network connectivity to other applications and
users. Ncat will not only work with IPv4 and IPv6 but provides the
user with a virtually limitless number of potential uses.

%description ncat -l pl.UTF-8
Ncat to narzędzie sieciowe o wielu możliwościach, czytające i
zapisujące dane przez sieć z linii poleceń. Do komunikacji używa
zarówno TCP, jak i UDP; jest zaprojektowane jako wiarygodne narzędzie
backendowe, zapewniające łączność sieciową dla innych aplikacji i
użytkowników. Działa nie tylko z IPv4 i IPv6, ale udostępnia
użytkownikowi praktycznie nieograniczoną liczbę potencjalnych
zastosowań.

%package ndiff
Summary:	ndiff - utility to compare the results of Nmap scans
Summary(pl.UTF-8):	ndiff - narzędzie do porównywania wyników skanowań Nmapa
Group:		Applications/Networking
Conflicts:	nmap < 7.91-2

%description ndiff
Ndiff is a tool to aid in the comparison of Nmap scans. It takes two
Nmap XML output files and prints the differences between them.

%description ndiff -l pl.UTF-8
Ndiff to narzędzie pomagające przy porównywaniu wyników skanowań
Nmapa. Przyjmuje dwa pliki wyjściowe Nmapa w formacie XML i wypisuje
różnice między nimi.

%package zenmap
Summary:	Graphical frontend for nmap
Summary(pl.UTF-8):	Graficzny frontend dla nmapa
Group:		X11/Applications/Networking
Requires:	%{name} = %{version}-%{release}
Requires:	bash
Requires:	python3-modules >= 1:3.6
Requires:	python3-pygobject3
Suggests:	gksu
Provides:	nmap-X11
Obsoletes:	nmap-X11 < 4.53
Obsoletes:	nmap-frontend < 3

%description zenmap
This package includes zenmap, a graphical frontend for nmap.

%description zenmap -l pl.UTF-8
Ten pakiet zawiera zenmap, czyli graficzny frontend dla nmapa.

%prep
%setup -q
%patch -P 0 -p1
%patch -P 1 -p1
%patch -P 2 -p1 -b .orig
# use system provided libraries
%{__rm} -r liblinear liblua libpcap libpcre libssh2 libz

%build
%{__autoheader}
cd ncat
%{__autoheader}
cd ..
%configure \
	PYTHON=%{__python3} \
	STRIP=/bin/true \
	--with-liblinear \
	--with-lua%{!?with_lua:=no} \
	--with-libdnet%{!?with_system_dnet:=included} \
	--with-zenmap%{!?with_python:=no} \
	--with-ndiff%{!?with_python:=no}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_pixmapsdir}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%if %{with python}
#cp -p docs/zenmap.1 $RPM_BUILD_ROOT%{_mandir}/man1

#py3_ocomp $RPM_BUILD_ROOT%{py3_sitescriptdir}

# missing in intermediate python wheel (why???)
cp -pr zenmap/zenmapCore/data/locale/{??,??_??} $RPM_BUILD_ROOT%{py3_sitescriptdir}/zenmapCore/data/locale
install zenmap/install_scripts/unix/su-to-zenmap.sh $RPM_BUILD_ROOT%{_bindir}

# unify locale names
%{__mv} $RPM_BUILD_ROOT%{py3_sitescriptdir}/zenmapCore/data/locale/zh{,_CN}
%endif

# unify locale names
%{__mv} $RPM_BUILD_ROOT%{_mandir}/pt{_PT,}
%{__mv} $RPM_BUILD_ROOT%{_mandir}/zh{,_CN}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc docs/README docs/*.txt CHANGELOG HACKING
%attr(755,root,root) %{_bindir}/nmap
%attr(755,root,root) %{_bindir}/nping
%{_datadir}/nmap
%exclude %{_datadir}/nmap/nselib/data/jdwp-class
%exclude %{_datadir}/nmap/scripts/jdwp-*
%{_mandir}/man1/nmap.1*
%{_mandir}/man1/nping.1*
%lang(de) %{_mandir}/de/man1/nmap.1*
%lang(es) %{_mandir}/es/man1/nmap.1*
%lang(fr) %{_mandir}/fr/man1/nmap.1*
%lang(hr) %{_mandir}/hr/man1/nmap.1*
%lang(hu) %{_mandir}/hu/man1/nmap.1*
%lang(it) %{_mandir}/it/man1/nmap.1*
%lang(ja) %{_mandir}/ja/man1/nmap.1*
%lang(pl) %{_mandir}/pl/man1/nmap.1*
%lang(pt_BR) %{_mandir}/pt_BR/man1/nmap.1*
%lang(pt) %{_mandir}/pt/man1/nmap.1*
%lang(ro) %{_mandir}/ro/man1/nmap.1*
%lang(ru) %{_mandir}/ru/man1/nmap.1*
%lang(sk) %{_mandir}/sk/man1/nmap.1*
%lang(zh_CN) %{_mandir}/zh_CN/man1/nmap.1*

%files java
%defattr(644,root,root,755)
%{_datadir}/nmap/nselib/data/jdwp-class
%{_datadir}/nmap/scripts/jdwp-*

%files ncat
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/ncat
%{_mandir}/man1/ncat.1*

%if %{with python}
%files ndiff
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/ndiff
%{_mandir}/man1/ndiff.1*
%{py3_sitescriptdir}/__pycache__/ndiff.cpython-*.py[co]
%{py3_sitescriptdir}/ndiff.py
%{py3_sitescriptdir}/ndiff-7.96.dist-info

%files zenmap
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/nmapfe
%attr(755,root,root) %{_bindir}/su-to-zenmap.sh
%attr(755,root,root) %{_bindir}/xnmap
%attr(755,root,root) %{_bindir}/zenmap
%dir %{py3_sitescriptdir}/radialnet
%dir %{py3_sitescriptdir}/radialnet/bestwidgets
%dir %{py3_sitescriptdir}/radialnet/core
%dir %{py3_sitescriptdir}/radialnet/gui
%dir %{py3_sitescriptdir}/radialnet/util
%dir %{py3_sitescriptdir}/zenmapCore
%dir %{py3_sitescriptdir}/zenmapGUI
%dir %{py3_sitescriptdir}/zenmapGUI/higwidgets
%{py3_sitescriptdir}/radialnet/__pycache__
%{py3_sitescriptdir}/radialnet/*.py
%{py3_sitescriptdir}/radialnet/bestwidgets/__pycache__
%{py3_sitescriptdir}/radialnet/bestwidgets/*.py
%{py3_sitescriptdir}/radialnet/core/__pycache__
%{py3_sitescriptdir}/radialnet/core/*.py
%{py3_sitescriptdir}/radialnet/gui/__pycache__
%{py3_sitescriptdir}/radialnet/gui/*.py
%{py3_sitescriptdir}/radialnet/util/__pycache__
%{py3_sitescriptdir}/radialnet/util/*.py
%{py3_sitescriptdir}/zenmapCore/__pycache__
%{py3_sitescriptdir}/zenmapCore/*.py
%dir %{py3_sitescriptdir}/zenmapCore/data
%{py3_sitescriptdir}/zenmapCore/data/config
%{py3_sitescriptdir}/zenmapCore/data/docs
%{py3_sitescriptdir}/zenmapCore/data/misc
%dir %{py3_sitescriptdir}/zenmapCore/data/locale
%{py3_sitescriptdir}/zenmapCore/data/locale/xgettext-profile_editor.py
%{py3_sitescriptdir}/zenmapCore/data/locale/__pycache__
%lang(de) %{py3_sitescriptdir}/zenmapCore/data/locale/de
%lang(es) %{py3_sitescriptdir}/zenmapCore/data/locale/es
%lang(fr) %{py3_sitescriptdir}/zenmapCore/data/locale/fr
%lang(hi) %{py3_sitescriptdir}/zenmapCore/data/locale/hi
%lang(hr) %{py3_sitescriptdir}/zenmapCore/data/locale/hr
%lang(it) %{py3_sitescriptdir}/zenmapCore/data/locale/it
%lang(ja) %{py3_sitescriptdir}/zenmapCore/data/locale/ja
%lang(pl) %{py3_sitescriptdir}/zenmapCore/data/locale/pl
%lang(pt_BR) %{py3_sitescriptdir}/zenmapCore/data/locale/pt_BR
%lang(ru) %{py3_sitescriptdir}/zenmapCore/data/locale/ru
%lang(zh_CN) %{py3_sitescriptdir}/zenmapCore/data/locale/zh_CN
%{py3_sitescriptdir}/zenmapCore/data/pixmaps
%{py3_sitescriptdir}/zenmapGUI/__pycache__
%{py3_sitescriptdir}/zenmapGUI/*.py
%{py3_sitescriptdir}/zenmapGUI/higwidgets/__pycache__
%{py3_sitescriptdir}/zenmapGUI/higwidgets/*.py
%{py3_sitescriptdir}/zenmap-%{version}.dist-info
%{_desktopdir}/zenmap-root.desktop
%{_desktopdir}/zenmap.desktop
%{_mandir}/man1/zenmap.1*
%endif
%changelog
* Mon Jul 07 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/nmap.git;a=log;h=master

* Mon Jul 07 2025 Jakub Bogusz <qboosh@pld-linux.org> 8439afe
- updated to 7.97

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 5bd88f5
- Release 3 (by relup.sh)

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> d599273
- use patch -P

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 3f251de
- python 3.13 rebuild

* Sat Sep 09 2023 Jakub Bogusz <qboosh@pld-linux.org> bf0ae15
- cleanup, do also optimized byte-compilation

* Sat Sep 09 2023 Jan Rękorajski <baggins@pld-linux.org> 73947ba
- up to 7.94

* Wed Jan 18 2023 Jakub Bogusz <qboosh@pld-linux.org> 2074e6f
- release 2 (liblinear soname change)

* Mon Jan 16 2023 Jakub Bogusz <qboosh@pld-linux.org> 76d1ff0
- pl for -java

* Wed Sep 07 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 9cfffc6
- up to 7.93

* Fri Sep 24 2021 Jan Rękorajski <baggins@pld-linux.org> ef1ec6d
- rebuild with openssl 3.0.0

* Thu Aug 26 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 03da382
- up to 7.92

* Mon Aug 02 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> a9ac6b2
- Rel 4. Fix license. Split scripts that require java into subpackage.

* Thu Jul 15 2021 Bartek Szady <bszx@bszx.eu> 70ebedd
- removed jre dependency (java code is run on target)

* Sun May 30 2021 Jakub Bogusz <qboosh@pld-linux.org> 2f850e6
- separated ndiff (optional, python2 dependency); release 2

* Sun May 30 2021 Jakub Bogusz <qboosh@pld-linux.org> b59321f
- unified packages order

* Sun May 30 2021 Jakub Bogusz <qboosh@pld-linux.org> 6d53ff5
- versioned Obsoletes

* Sun May 30 2021 Jakub Bogusz <qboosh@pld-linux.org> 42578d4
- package zenmap es locale

* Wed May 26 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> d447c83
- https-ing Source0

* Wed May 26 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> cd6b49b
- up to 7.91

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 834e5bf
- release 2 (by relup.sh)

